<?php

namespace app\controllers\mikrotik\switchm;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\MikrotikSideMenu;
use app\models\mikrotik\switchm\Host;
use app\models\mikrotik\switchm\Switchm;
use app\models\mikrotik\interfaces\Ethernet;

class HostController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_switchCreateHost'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_switchDeleteHost'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_switchDisableHost'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_switchEnableHost'],
                    ],
                    [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_switchUpdateHost'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $model = new Host();
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Host();
        $inter = new Ethernet();
        $eth = $inter->getNames();
        $sw = new Switchm();
        $swName = $sw->getNames();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $opt = $_POST['Host']['ports'];
            if ($opt != '') {
                $opt = implode(",", $opt);
            }
            $model->ports = $opt;
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/switchm/switchm/index'));
            }
        } else {
            $model->get($id);
        }
        $model->ports = explode(',', $model->ports);
        return $this->render('/mikrotik/switchm/host', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'interfaces' => $eth,
                    'swName' => $swName,
        ]);
    }

    public function actionCreate() {

        $menu = new MikrotikSideMenu();
        $model = new Host();
        $inter = new Ethernet();
        $sw = new Switchm();
        $swName = $sw->getNames();
        $eth = $inter->getNames();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $opt = $_POST['Host']['ports'];
            if ($opt != '') {
                $opt = implode(",", $opt);
            }
            $model->ports = $opt;
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/switchm/switchm/index'));
            }
        }

        return $this->render('/mikrotik/switchm/host', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'interfaces' => $eth,
                    'swName' => $swName,
        ]);
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Host();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/switchm/switchm/index'));
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Host();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/switchm/switchm/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Host();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/switchm/switchm/index'));
    }

}
